; new keywrd for prowess
; ADDS NEW TAGS TO THE PW KEYWORD
; v. 1.01 1997 Jul 03 01:38:27

	section	text

	xdef	loadpwdefn
	xref	getstr
	xref	gu_achp
	xref	gu_achp0
	xref	gu_rchp
	xref	strings


marker	EQU	'WLPW'
marker2	EQU	'DEFN'

****************************************************
*
*	syntax:	LPWDEFN filename
*	loads the definition file
*
****************************************************

loadpwdefn   BSR	   getstr 	   ; get string
	BNE	out		; oops->...
	MOVE.L	D1,D7
	MOVE.W	#100,D0
	JSR	gu_achp		; get mem, 100 bytes
	BNE	out		; oops->...
	MOVE.L	A0,A2
	MOVE.W	D7,(A2)+		; tansfer filename
copyname	MOVE.B	(A1)+,(A2)+
	DBF	D7,copyname
	MOVE.L	A0,A2		; keep this mempointer
	MOVEQ	#-1,D1		; it's me
	MOVEQ	#1,D3		; old file
	MOVEQ	#1,D0
	TRAP	#2		; try to open the file
	TST.L	D0
	BNE.S	out		; oops->...
	MOVE.L	A2,A1		; buffer base
	MOVEQ	#-1,D3		; timeout

	MOVEQ	#$47,D0
	TRAP	#3		; read file header
	MOVE.L	(A2),D7		; file length
	EXG	A0,A2		; A2 = channel ID, A0 = mempointer
	JSR	gu_rchp		; release the 100 bytes now
	MOVE.L	D7,D0		; mem to reserve
	BEQ.S	out2		; 0 length file: oops?->...
	JSR	gu_achp0		; get memory for the file now
	BNE.S	out2		; oops
	MOVE.L	D7,D2		; number of bytes to load, entire file
	MOVE.L	A0,A1
	EXG	A2,A0		; A0=channel ID, A2 = mempointer
	MOVEQ	#-1,D3
	MOVEQ	#$48,D0
	TRAP	#3		; load the file
	TST.L	D0
	BNE.S	out3		; oops->...
	MOVEQ	#2,D0
	TRAP	#2		; close the file
	MOVEQ	#-15,D0
	CMP.L	#marker,(A2)+
	BNE.S	out
	CMP.L	#marker2,(A2)+
	BNE.S	out
	LEA	strings+4,A0	; point to first strings now
srchloop	MOVE.W	(A0)+,D0		; length
	BEQ.S	found_end 	; we are at the end of the strings here!
	BLT.S	ptr		; pointer to other area already
	ADDQ.W	#1,D0
	BCLR	#0,D0
	ADD.W	D0,A0		; point to next string
	BRA.S	srchloop
ptr	MOVE.L	(A0),A0		; pointer to the next stage
	ADDQ.L	#4,A0		; jump over rel pointer to values
	BRA.S	srchloop		; and do it again...
found_end MOVE.W	#-1,-2(A0)	; change marker to show ptr
	MOVE.L	A2,(A0)+		; pointer to next strings
	MOVEQ	#0,D0
	RTS



out3	MOVE.L	D0,D7
	EXG	A0,A2
	JSR	gu_rchp	         ; release mem for file now
	MOVE.L	D7,D0
out2	MOVE.L	A2,A0
	MOVE.L	D0,D7
	MOVEQ	#2,D0
	TRAP	#2		; close the file
	MOVE.L	D7,D0		; get error back
out	RTS


	END

the file looks as follows
    ====

offset	type	content

0	dc.l	marker1
4	dc.l	marker2
8	dc.l	rel pointer to values
12	 dc.w	 first length word for strings
....
xx	dc.w	last length worg for string
	dc.b	chars of string, even'd up
	dc.w	0
	dc.l	0 - used for absolute pointer to next block
values

....

This is loaded into memory as such. When another block is later loaded,
the dc.l pointer is made to point to that block, and the dc.w is set
to -1.
